/*******************************************************************************
 * Size: 16 px
 * Bpp: 4
 * Opts: 
 ******************************************************************************/

#ifdef LV_LVGL_H_INCLUDE_SIMPLE
#include "lvgl.h"
#else
#include "lvgl/lvgl.h"
#endif

#ifndef MXC_WRYH_BPP4_16PX
#define MXC_WRYH_BPP4_16PX 1
#endif

#if MXC_WRYH_BPP4_16PX

/*-----------------
 *    BITMAPS
 *----------------*/

/*Store the image of the glyphs*/
#include "bin_font.h" 

/*---------------------
 *  GLYPH DESCRIPTION
 *--------------------*/

 
/*---------------------
 *  CHARACTER MAPPING
 *--------------------*/

static const uint16_t unicode_list_3[] = {
    0x0, 0x5690, 0x5b58, 0x5dbc, 0x5f84, 0x653f, 0x6649, 0x7954,
    0x8aea, 0x8f68, 0x9115, 0x9a21
};

/*Collect the unicode lists and glyph_id offsets*/
static const lv_font_fmt_txt_cmap_t cmaps[] =
{
    {
        .range_start = 46, .range_length = 13, .glyph_id_start = 1,
        .unicode_list = NULL, .glyph_id_ofs_list = NULL, .list_length = 0, .type = LV_FONT_FMT_TXT_CMAP_FORMAT0_TINY
    },
    {
        .range_start = 65, .range_length = 26, .glyph_id_start = 14,
        .unicode_list = NULL, .glyph_id_ofs_list = NULL, .list_length = 0, .type = LV_FONT_FMT_TXT_CMAP_FORMAT0_TINY
    },
    {
        .range_start = 97, .range_length = 26, .glyph_id_start = 40,
        .unicode_list = NULL, .glyph_id_ofs_list = NULL, .list_length = 0, .type = LV_FONT_FMT_TXT_CMAP_FORMAT0_TINY
    },
    {
        .range_start = 183, .range_length = 39458, .glyph_id_start = 66,
        .unicode_list = unicode_list_3, .glyph_id_ofs_list = NULL, .list_length = 12, .type = LV_FONT_FMT_TXT_CMAP_SPARSE_TINY
    }
};

/*-----------------
 *    KERNING
 *----------------*/


/*Pair left and right glyphs for kerning*/
static const uint8_t kern_pair_glyph_ids[] =
{
    14, 16,
    14, 20,
    14, 23,
    14, 28,
    14, 33,
    14, 34,
    14, 35,
    14, 36,
    14, 38,
    14, 39,
    14, 59,
    14, 61,
    14, 62,
    14, 64,
    15, 33,
    15, 38,
    16, 16,
    16, 20,
    16, 28,
    16, 30,
    17, 1,
    17, 14,
    17, 33,
    17, 37,
    17, 39,
    18, 14,
    18, 23,
    18, 33,
    18, 36,
    18, 37,
    19, 1,
    19, 14,
    19, 23,
    19, 32,
    19, 33,
    19, 40,
    19, 45,
    20, 33,
    20, 35,
    20, 64,
    23, 1,
    23, 14,
    23, 23,
    23, 40,
    24, 16,
    24, 20,
    24, 23,
    24, 28,
    24, 30,
    24, 37,
    24, 39,
    24, 42,
    24, 43,
    24, 44,
    24, 46,
    24, 54,
    24, 56,
    24, 59,
    24, 61,
    24, 62,
    24, 64,
    25, 14,
    25, 16,
    25, 20,
    25, 23,
    25, 28,
    25, 30,
    25, 33,
    25, 34,
    25, 35,
    25, 36,
    25, 38,
    25, 39,
    25, 59,
    25, 61,
    25, 62,
    25, 64,
    28, 1,
    28, 14,
    28, 23,
    28, 33,
    28, 37,
    28, 38,
    28, 39,
    29, 1,
    29, 14,
    29, 20,
    29, 23,
    29, 36,
    29, 37,
    29, 40,
    29, 42,
    29, 43,
    29, 44,
    29, 46,
    29, 54,
    29, 56,
    30, 1,
    30, 14,
    30, 33,
    30, 37,
    30, 38,
    30, 39,
    31, 16,
    31, 20,
    31, 23,
    31, 28,
    31, 30,
    31, 33,
    31, 38,
    31, 42,
    31, 43,
    31, 44,
    31, 46,
    31, 54,
    31, 56,
    32, 59,
    32, 61,
    32, 62,
    32, 64,
    33, 1,
    33, 13,
    33, 14,
    33, 16,
    33, 20,
    33, 23,
    33, 28,
    33, 30,
    33, 33,
    33, 35,
    33, 36,
    33, 37,
    33, 38,
    33, 40,
    33, 42,
    33, 43,
    33, 44,
    33, 45,
    33, 46,
    33, 52,
    33, 53,
    33, 54,
    33, 55,
    33, 56,
    33, 57,
    33, 58,
    33, 60,
    33, 61,
    33, 62,
    33, 63,
    33, 64,
    33, 65,
    34, 14,
    35, 1,
    35, 14,
    35, 16,
    35, 20,
    35, 23,
    35, 28,
    35, 30,
    35, 32,
    35, 33,
    35, 40,
    35, 42,
    35, 43,
    35, 44,
    35, 46,
    35, 52,
    35, 53,
    35, 54,
    35, 55,
    35, 56,
    35, 57,
    35, 58,
    35, 60,
    36, 1,
    36, 14,
    36, 33,
    36, 40,
    36, 42,
    36, 43,
    36, 44,
    36, 46,
    36, 54,
    36, 56,
    37, 1,
    37, 16,
    37, 20,
    37, 23,
    37, 28,
    37, 30,
    37, 33,
    38, 1,
    38, 14,
    38, 16,
    38, 20,
    38, 23,
    38, 28,
    38, 30,
    38, 32,
    38, 33,
    38, 40,
    38, 42,
    38, 43,
    38, 44,
    38, 45,
    38, 46,
    38, 52,
    38, 53,
    38, 54,
    38, 55,
    38, 56,
    38, 57,
    38, 58,
    38, 60,
    39, 23,
    39, 33,
    39, 64,
    41, 40,
    41, 45,
    41, 63,
    42, 23,
    42, 33,
    42, 38,
    45, 1,
    45, 13,
    45, 41,
    45, 47,
    45, 59,
    45, 61,
    45, 62,
    45, 63,
    45, 64,
    46, 49,
    49, 49,
    50, 1,
    50, 13,
    50, 42,
    50, 43,
    50, 44,
    50, 46,
    50, 54,
    50, 56,
    50, 59,
    54, 40,
    54, 45,
    54, 63,
    55, 40,
    55, 45,
    55, 63,
    56, 49,
    57, 1,
    57, 13,
    57, 42,
    57, 43,
    57, 44,
    57, 45,
    57, 46,
    57, 52,
    57, 53,
    57, 54,
    57, 56,
    57, 58,
    57, 59,
    57, 61,
    57, 62,
    57, 63,
    57, 64,
    57, 65,
    59, 42,
    59, 43,
    59, 44,
    59, 46,
    59, 54,
    59, 56,
    59, 63,
    61, 1,
    61, 40,
    61, 42,
    61, 43,
    61, 44,
    61, 46,
    61, 54,
    61, 56,
    62, 1,
    62, 42,
    62, 43,
    62, 44,
    62, 46,
    62, 54,
    62, 56,
    63, 42,
    63, 43,
    63, 44,
    63, 46,
    63, 54,
    63, 56,
    64, 1,
    64, 42,
    64, 43,
    64, 44,
    64, 45,
    64, 46,
    64, 54,
    64, 56,
    64, 59
};

/* Kerning between the respective left and right glyphs
 * 4.4 format which needs to scaled with `kern_scale`*/
static const int8_t kern_pair_values[] =
{
    -4, -4, 13, -4, -20, -4, -16, -10,
    -21, 8, -4, -6, -4, -5, -12, -9,
    -7, -7, -4, -7, -17, -4, -12, -7,
    -7, 1, 9, 1, 4, 1, -21, -18,
    -9, -4, 2, -10, 1, -7, -4, -4,
    -14, -5, -9, -4, -12, -12, 12, -12,
    -12, 5, 5, -4, -4, -4, -4, -4,
    -4, -6, -10, -7, -12, 8, -9, -9,
    14, -9, -9, -15, -4, -16, -7, -17,
    8, -4, -14, -9, -10, -12, -4, -1,
    -12, -5, -3, -7, -44, -21, -1, -17,
    5, -8, -9, -10, -10, -10, -10, -10,
    -10, -17, -4, -12, -5, -1, -7, -4,
    -4, 8, -3, -3, -7, -5, -7, -7,
    -8, -8, -8, -7, -9, -7, -4, -6,
    -24, -3, -21, -12, -12, -15, -12, -12,
    5, 6, 5, -1, 4, -29, -28, -28,
    -28, -13, -28, -24, -24, -28, -24, -28,
    -24, -21, -24, -14, -15, -24, -15, -17,
    -5, -31, -16, -6, -6, -9, -2, -6,
    -4, 5, -20, -17, -17, -17, -17, -10,
    -10, -17, -10, -17, -10, -9, -10, -17,
    -10, 5, -10, -7, -7, -7, -7, -7,
    -7, 8, -3, -3, 13, -3, -3, 5,
    -26, -21, -6, -6, -9, -6, -6, -4,
    5, -27, -24, -24, -24, -4, -24, -19,
    -19, -24, -19, -24, -19, -18, -19, 11,
    5, -7, -4, -1, -3, 10, -14, -10,
    -17, 11, 2, 2, 5, 5, 5, 2,
    5, 6, 5, 11, 11, -5, -4, -5,
    -5, -5, -4, -2, -4, -5, -3, -4,
    -5, -3, 14, -23, 11, -4, -4, -4,
    5, -4, 0, 0, -4, -4, 2, 8,
    11, 11, 8, 11, 5, -4, -4, -2,
    -2, -2, -2, 4, -17, -5, -2, -2,
    -2, -2, -2, -2, -14, -1, -1, -1,
    -1, -1, -1, -2, -2, -2, -2, -2,
    -2, -17, -1, -1, -1, 1, -1, -1,
    -1, 1
};

/*Collect the kern pair's data in one place*/
static const lv_font_fmt_txt_kern_pair_t kern_pairs =
{
    .glyph_ids = kern_pair_glyph_ids,
    .values = kern_pair_values,
    .pair_cnt = 306,
    .glyph_ids_size = 0
};

/*--------------------
 *  ALL CUSTOM DATA
 *--------------------*/

#if LVGL_VERSION_MAJOR == 8
/*Store all the custom data of the font*/
static  lv_font_fmt_txt_glyph_cache_t cache;
#endif

#if LVGL_VERSION_MAJOR >= 8
static const lv_font_fmt_txt_dsc_t font_dsc = {
#else
static lv_font_fmt_txt_dsc_t font_dsc = {
#endif
    .glyph_bitmap = MXC_WRYH_bpp4_16px_glyph_bitmap,
    .glyph_dsc = MXC_WRYH_bpp4_16px_glyph_dsc,
    .cmaps = cmaps,
    .kern_dsc = &kern_pairs,
    .kern_scale = 16,
    .cmap_num = 4,
    .bpp = 4,
    .kern_classes = 0,
    .bitmap_format = 0,
#if LVGL_VERSION_MAJOR == 8
    .cache = &cache
#endif
};


/*-----------------
 *  PUBLIC FONT
 *----------------*/

/*Initialize a public general font descriptor*/
#if LVGL_VERSION_MAJOR >= 8
const lv_font_t MXC_WRYH_bpp4_16px = {
#else
lv_font_t MXC_WRYH_bpp4_16px = {
#endif
    .get_glyph_dsc = lv_font_get_glyph_dsc_fmt_txt,    /*Function pointer to get glyph's data*/
    .get_glyph_bitmap = lv_font_get_bitmap_fmt_txt,    /*Function pointer to get glyph's bitmap*/
    .line_height = 18,          /*The maximum line height required by the font*/
    .base_line = 4,             /*Baseline measured from the bottom of the line*/
#if !(LVGL_VERSION_MAJOR == 6 && LVGL_VERSION_MINOR == 0)
    .subpx = LV_FONT_SUBPX_NONE,
#endif
#if LV_VERSION_CHECK(7, 4, 0) || LVGL_VERSION_MAJOR >= 8
    .underline_position = -1,
    .underline_thickness = 1,
#endif
    .dsc = &font_dsc,          /*The custom font data. Will be accessed by `get_glyph_bitmap/dsc` */
    .fallback = NULL,
    .user_data = NULL
};



#endif /*#if MXC_WRYH_BPP4_16PX*/

