/*******************************************************************************
 * Size: 20 px
 * Bpp: 4
 * Opts: --no-compress --format lvgl --font HarmonyOS_Sans_SC_Medium.ttf -o Number_HarmonyOS_bpp4_20px.c --bpp 4 --size 20 -r 0x00-0x7f
 ******************************************************************************/

#ifdef LV_LVGL_H_INCLUDE_SIMPLE
#include "lvgl.h"
#else
#include "lvgl/lvgl.h"
#endif

#ifndef NUMBER_HARMONYOS_BPP4_20PX
#define NUMBER_HARMONYOS_BPP4_20PX 1
#endif

#if NUMBER_HARMONYOS_BPP4_20PX

/*-----------------
 *    BITMAPS
 *----------------*/

/*Store the image of the glyphs*/
#include "bin_font.h" 

/*---------------------
 *  GLYPH DESCRIPTION
 *--------------------*/

 
/*---------------------
 *  CHARACTER MAPPING
 *--------------------*/



/*Collect the unicode lists and glyph_id offsets*/
static const lv_font_fmt_txt_cmap_t cmaps[] =
{
    {
        .range_start = 0, .range_length = 1, .glyph_id_start = 1,
        .unicode_list = NULL, .glyph_id_ofs_list = NULL, .list_length = 0, .type = LV_FONT_FMT_TXT_CMAP_FORMAT0_TINY
    },
    {
        .range_start = 32, .range_length = 95, .glyph_id_start = 2,
        .unicode_list = NULL, .glyph_id_ofs_list = NULL, .list_length = 0, .type = LV_FONT_FMT_TXT_CMAP_FORMAT0_TINY
    }
};

/*-----------------
 *    KERNING
 *----------------*/


/*Map glyph_ids to kern left classes*/
static const uint8_t kern_left_class_mapping[] =
{
    0, 0, 0, 0, 1, 0, 0, 0,
    0, 1, 2, 3, 0, 4, 0, 4,
    0, 5, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    4, 6, 7, 8, 9, 10, 7, 11,
    12, 13, 14, 14, 15, 16, 17, 14,
    14, 7, 18, 0, 19, 20, 21, 15,
    5, 22, 23, 24, 25, 2, 8, 3,
    0, 0, 0, 26, 27, 28, 29, 30,
    31, 32, 26, 0, 33, 34, 29, 26,
    26, 27, 27, 0, 35, 36, 37, 32,
    38, 38, 39, 38, 40, 2, 0, 3,
    4
};

/*Map glyph_ids to kern right classes*/
static const uint8_t kern_right_class_mapping[] =
{
    0, 0, 1, 0, 2, 0, 0, 0,
    0, 2, 0, 3, 0, 4, 5, 4,
    5, 6, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 4, 0,
    0, 7, 8, 6, 9, 8, 9, 9,
    9, 8, 9, 9, 10, 9, 9, 9,
    9, 8, 9, 8, 9, 11, 12, 13,
    14, 15, 16, 17, 18, 0, 14, 3,
    0, 5, 0, 19, 20, 21, 21, 21,
    22, 21, 20, 0, 23, 20, 20, 24,
    24, 21, 0, 21, 24, 25, 26, 27,
    28, 28, 29, 30, 31, 0, 0, 3,
    4
};

/*Kern values between classes*/
static const int8_t kern_class_values[] =
{
    0, 0, 0, 0, 0, 0, 5, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 6, 0, 6, 6,
    3, 0, 4, 0, 0, 22, 0, 0,
    6, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 8, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, -17, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, -13, 6, 6, -14,
    -45, -29, 7, -12, 0, -39, -3, 6,
    0, 0, 0, 0, 0, 0, -24, 0,
    -24, -8, 0, -15, -19, -2, -15, -14,
    -18, -14, -17, 0, 0, 0, -11, -32,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, -7, 0, 0, -14, -12,
    0, 0, 0, -12, 0, -10, 0, -12,
    -6, -11, -18, -7, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, -13, -37, 0, -20, 8, 0, -22,
    -12, 0, 0, 0, -27, -5, -29, -22,
    0, -36, 7, 0, 0, -4, 0, 0,
    0, 0, 0, 0, -14, 0, -14, 0,
    0, -4, 0, 0, 0, -5, 0, 0,
    0, 4, 0, -11, 0, -14, -5, 0,
    -18, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    3, 0, -10, 7, 0, 11, -5, 0,
    0, 0, 2, 0, -1, 0, 0, -1,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, -7, 0, -7, 0, 0, 0,
    0, 0, 3, 0, 4, -3, 0, 4,
    0, 0, 0, -4, 0, 0, -4, 0,
    -3, 0, -4, -4, 0, 0, -3, -3,
    -3, -7, -3, -7, 0, -3, 8, 0,
    2, -42, -19, 13, -2, 0, -44, 0,
    7, 0, 0, 0, 0, 0, 0, -13,
    0, -9, -3, 0, -6, 0, -4, 0,
    -7, -12, -7, -8, 0, 0, 0, 0,
    6, 0, 4, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 2, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, -10, -5,
    0, 0, 0, -10, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, -13, 0, 0, -35, 6, 0, -2,
    -19, -5, 0, -5, 0, -8, 0, 0,
    0, 0, 0, -9, 0, -11, -13, 0,
    -5, -5, -13, -13, -21, -11, -21, 0,
    -16, -33, 0, -29, 8, 0, -23, -15,
    0, 5, -3, -42, -14, -47, -35, 0,
    -57, 0, -2, 0, -6, -6, 0, -1,
    0, -9, -8, -30, 0, -30, 0, -3,
    3, 0, 4, -46, -26, 5, 0, 0,
    -51, 0, 0, 0, -1, -2, -8, 0,
    -10, -11, 0, -10, 0, 0, 0, 0,
    0, 0, 4, 0, 4, 0, 0, -4,
    0, -3, 12, 0, -1, -3, 0, 0,
    2, -4, -4, -9, -6, 0, -16, 0,
    0, 0, -4, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 3, 0, 0, 0, 7,
    0, 0, -5, 0, 0, -7, 2, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, -10, 10, 0, -26,
    -36, -27, 12, -10, 0, -45, 0, 7,
    0, 6, 6, 0, 0, 0, -38, 0,
    -36, -14, 0, -29, -36, -11, -28, -34,
    -34, -34, -28, -3, 6, 0, -8, -25,
    -22, 0, -6, 0, -23, -1, 6, 0,
    0, 0, 0, 0, 0, -25, 0, -20,
    -5, 0, -14, -15, 0, -11, -7, -11,
    -7, -11, 0, 0, 6, -29, 3, 0,
    4, -11, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, -8, 0, -11, 0,
    0, -5, -6, -10, -10, -20, 0, -20,
    0, -10, 4, 6, -23, -44, -36, 3,
    -18, 0, -44, -8, 0, 0, 0, 0,
    0, 0, 0, -36, 0, -34, -16, 0,
    -27, -30, -11, -25, -24, -22, -24, -25,
    0, 0, 3, -15, 6, 0, 3, -9,
    0, 0, -3, 0, 0, 0, 0, 0,
    0, 0, -2, 0, -5, 0, 0, 0,
    0, 0, 0, -11, 0, -11, 0, 0,
    -13, 0, -1, 0, 0, -10, 0, 0,
    0, 0, -28, 0, -24, -21, -3, -32,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, -4, 0, -4, 0, 0, -16,
    0, -3, -10, 0, -13, 0, 0, 0,
    0, -36, 0, -24, -20, -11, -34, 0,
    -3, 0, 0, -3, 0, 0, 0, -2,
    0, -7, -8, -7, -7, 0, 1, 0,
    6, 8, 0, -4, 0, 0, 0, 0,
    -25, 0, -17, -11, 6, -25, 0, 1,
    0, -1, 4, 0, 0, 0, 7, 0,
    0, 2, 0, 4, 0, 0, 4, 0,
    0, 0, 4, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, -2, 0, 5, -1,
    0, -8, 0, 0, 0, 0, -23, 0,
    -21, -16, -4, -29, 0, 0, 0, 0,
    0, 0, 0, 4, 0, 0, -1, -2,
    -1, 0, 0, 15, 0, -2, -25, 0,
    14, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, -9, 0, -8, 1,
    0, 0, 0, 4, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, -9,
    0, 0, 0, 0, -29, 0, -15, -14,
    0, -27, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 4, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 13, 0,
    0, 0, 0, 0, 0, 0, 0, -7,
    0, 0, -9, 8, 0, -15, 0, 0,
    0, 0, -29, 0, -20, -18, 0, -27,
    0, -9, 0, -7, 0, 0, 0, -4,
    0, -3, 0, 0, 0, 0, 0, 8,
    0, 3, -35, -15, -9, 0, 0, -38,
    0, 0, 0, -14, 0, -16, -24, 0,
    -13, 0, -11, 0, 0, 0, -2, 9,
    0, 0, 0, 0, 0, 0, -9, 0,
    0, 0, 0, -10, 0, 0, 0, 0,
    -32, 0, -23, -16, -1, -34, 0, 0,
    0, 0, 0, 0, 0, 3, 0, 0,
    -3, 0, -3, 4, 0, -2, 3, -1,
    9, 0, -8, 0, 0, 0, 0, -22,
    0, -15, 0, -1, -22, 0, 0, 0,
    -3, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, -29,
    -14, -9, 0, 0, -26, 0, -34, 0,
    -14, -7, -20, -24, 0, -6, 0, -7,
    0, 0, 0, -3, 0, 0, 0, 0,
    0, 0, 0, 0, 0, -6, 3, 0,
    -13, 0, 0, 0, 0, -34, 0, -18,
    -11, 0, -22, 0, -5, 0, -8, 0,
    0, 0, 0, 4, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 3, 0, -10,
    0, 0, 0, 0, -31, 0, -18, -10,
    0, -24, 0, -5, 0, -7, 0, 0,
    0, 1, 0, 0, 0, 0, 0, 0
};


/*Collect the kern class' data in one place*/
static const lv_font_fmt_txt_kern_classes_t kern_classes =
{
    .class_pair_values   = kern_class_values,
    .left_class_mapping  = kern_left_class_mapping,
    .right_class_mapping = kern_right_class_mapping,
    .left_class_cnt      = 40,
    .right_class_cnt     = 31,
};

/*--------------------
 *  ALL CUSTOM DATA
 *--------------------*/

#if LVGL_VERSION_MAJOR >= 8
/*Store all the custom data of the font*/
static  lv_font_fmt_txt_glyph_cache_t cache;
static const lv_font_fmt_txt_dsc_t font_dsc = {
#else
static lv_font_fmt_txt_dsc_t font_dsc = {
#endif
    .glyph_bitmap = Number_HarmonyOS_bpp4_20px_glyph_bitmap,
    .glyph_dsc = Number_HarmonyOS_bpp4_20px_glyph_dsc,
    .cmaps = cmaps,
    .kern_dsc = &kern_classes,
    .kern_scale = 16,
    .cmap_num = 2,
    .bpp = 4,
    .kern_classes = 1,
    .bitmap_format = 0,
#if LVGL_VERSION_MAJOR >= 8
    .cache = &cache
#endif
};


/*-----------------
 *  PUBLIC FONT
 *----------------*/

/*Initialize a public general font descriptor*/
#if LVGL_VERSION_MAJOR >= 8
const lv_font_t Number_HarmonyOS_bpp4_20px = {
#else
lv_font_t Number_HarmonyOS_bpp4_20px = {
#endif
    .get_glyph_dsc = lv_font_get_glyph_dsc_fmt_txt,    /*Function pointer to get glyph's data*/
    .get_glyph_bitmap = lv_font_get_bitmap_fmt_txt,    /*Function pointer to get glyph's bitmap*/
    .line_height = 23,          /*The maximum line height required by the font*/
    .base_line = 5,             /*Baseline measured from the bottom of the line*/
#if !(LVGL_VERSION_MAJOR == 6 && LVGL_VERSION_MINOR == 0)
    .subpx = LV_FONT_SUBPX_NONE,
#endif
#if LV_VERSION_CHECK(7, 4, 0) || LVGL_VERSION_MAJOR >= 8
    .underline_position = -1,
    .underline_thickness = 1,
#endif
    .dsc = &font_dsc           /*The custom font data. Will be accessed by `get_glyph_bitmap/dsc` */
};



#endif /*#if NUMBER_HARMONYOS_BPP4_20PX*/

