/*******************************************************************************
 * Size: 28 px
 * Bpp: 4
 * Opts: --no-compress --format lvgl --font HarmonyOS_Sans_SC_Medium.ttf -o Number_HarmonyOS_bpp4_28px.c --bpp 4 --size 28 -r 0x20-0x7f
 ******************************************************************************/

#ifdef LV_LVGL_H_INCLUDE_SIMPLE
#include "lvgl.h"
#else
#include "lvgl/lvgl.h"
#endif

#ifndef NUMBER_HARMONYOS_BPP4_28PX
#define NUMBER_HARMONYOS_BPP4_28PX 1
#endif

#if NUMBER_HARMONYOS_BPP4_28PX

/*-----------------
 *    BITMAPS
 *----------------*/

/*Store the image of the glyphs*/
#include "bin_font.h" 

/*---------------------
 *  GLYPH DESCRIPTION
 *--------------------*/

 
/*---------------------
 *  CHARACTER MAPPING
 *--------------------*/



/*Collect the unicode lists and glyph_id offsets*/
static const lv_font_fmt_txt_cmap_t cmaps[] =
{
    {
        .range_start = 32, .range_length = 95, .glyph_id_start = 1,
        .unicode_list = NULL, .glyph_id_ofs_list = NULL, .list_length = 0, .type = LV_FONT_FMT_TXT_CMAP_FORMAT0_TINY
    }
};

/*-----------------
 *    KERNING
 *----------------*/


/*Map glyph_ids to kern left classes*/
static const uint8_t kern_left_class_mapping[] =
{
    0, 0, 0, 1, 0, 0, 0, 0,
    1, 2, 3, 0, 4, 0, 4, 0,
    5, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 4,
    6, 7, 8, 9, 10, 7, 11, 12,
    13, 14, 14, 15, 16, 17, 14, 14,
    7, 18, 0, 19, 20, 21, 15, 5,
    22, 23, 24, 25, 2, 8, 3, 0,
    0, 0, 26, 27, 28, 29, 30, 31,
    32, 26, 0, 33, 34, 29, 26, 26,
    27, 27, 0, 35, 36, 37, 32, 38,
    38, 39, 38, 40, 2, 0, 3, 4
};

/*Map glyph_ids to kern right classes*/
static const uint8_t kern_right_class_mapping[] =
{
    0, 1, 0, 2, 0, 0, 0, 0,
    2, 0, 3, 0, 4, 5, 4, 5,
    6, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 4, 0, 0,
    7, 8, 6, 9, 8, 9, 9, 9,
    8, 9, 9, 10, 9, 9, 9, 9,
    8, 9, 8, 9, 11, 12, 13, 14,
    15, 16, 17, 18, 0, 14, 3, 0,
    5, 0, 19, 20, 21, 21, 21, 22,
    21, 20, 0, 23, 20, 20, 24, 24,
    21, 0, 21, 24, 25, 26, 27, 28,
    28, 29, 30, 31, 0, 0, 3, 4
};

/*Kern values between classes*/
static const int8_t kern_class_values[] =
{
    0, 0, 0, 0, 0, 0, 7, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 9, 0, 9, 9,
    4, 0, 6, 0, 0, 31, 0, 0,
    8, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 11, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, -24, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, -18, 8, 9, -20,
    -64, -41, 10, -17, 0, -54, -4, 9,
    0, 0, 0, 0, 0, 0, -34, 0,
    -33, -11, 0, -22, -26, -3, -22, -20,
    -25, -20, -24, 0, 0, 0, -15, -45,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, -10, 0, 0, -19, -16,
    0, 0, 0, -16, 0, -14, 0, -17,
    -9, -16, -25, -10, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, -18, -52, 0, -28, 12, 0, -30,
    -16, 0, 0, 0, -38, -7, -41, -31,
    0, -50, 9, 0, 0, -5, 0, 0,
    0, 0, 0, 0, -19, 0, -19, 0,
    0, -6, 0, 0, 0, -7, 0, 0,
    0, 6, 0, -16, 0, -20, -7, 0,
    -26, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    4, 0, -14, 10, 0, 15, -7, 0,
    0, 0, 2, 0, -1, 0, 0, -1,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, -10, 0, -10, 0, 0, 0,
    0, 0, 4, 0, 5, -4, 0, 5,
    0, 0, 0, -5, 0, 0, -6, 0,
    -4, 0, -5, -6, 0, 0, -4, -4,
    -4, -9, -4, -9, 0, -4, 12, 0,
    3, -59, -26, 18, -2, 0, -62, 0,
    10, 0, 0, 0, 0, 0, 0, -18,
    0, -13, -4, 0, -8, 0, -6, 0,
    -10, -16, -10, -11, 0, 0, 0, 0,
    8, 0, 5, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 3, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, -13, -7,
    0, 0, 0, -13, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, -18, 0, 0, -49, 8, 0, -3,
    -26, -7, 0, -7, 0, -12, 0, 0,
    0, 0, 0, -13, 0, -15, -18, 0,
    -7, -7, -18, -19, -30, -15, -30, 0,
    -22, -46, 0, -40, 12, 0, -32, -22,
    0, 8, -4, -59, -19, -66, -49, 0,
    -80, 0, -3, 0, -9, -9, 0, -1,
    0, -13, -12, -43, 0, -43, 0, -4,
    4, 0, 5, -65, -36, 7, 0, 0,
    -72, 0, 0, 0, -1, -2, -11, 0,
    -13, -15, 0, -13, 0, 0, 0, 0,
    0, 0, 5, 0, 5, 0, 0, -5,
    0, -4, 17, 0, -2, -4, 0, 0,
    3, -6, -6, -13, -8, 0, -22, 0,
    0, 0, -6, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 4, 0, 0, 0, 10,
    0, 0, -7, 0, 0, -10, 3, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, -13, 13, 0, -36,
    -51, -38, 16, -14, 0, -63, 0, 10,
    0, 9, 9, 0, 0, 0, -53, 0,
    -50, -20, 0, -41, -50, -15, -39, -47,
    -48, -47, -39, -4, 8, 0, -11, -34,
    -31, 0, -9, 0, -33, -1, 9, 0,
    0, 0, 0, 0, 0, -34, 0, -28,
    -7, 0, -19, -21, 0, -16, -10, -15,
    -10, -15, 0, 0, 9, -41, 4, 0,
    6, -16, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, -11, 0, -16, 0,
    0, -8, -8, -14, -14, -27, 0, -27,
    0, -13, 6, 9, -32, -62, -50, 4,
    -25, 0, -61, -11, 0, 0, 0, 0,
    0, 0, 0, -51, 0, -48, -23, 0,
    -38, -42, -15, -35, -33, -31, -33, -34,
    0, 0, 4, -21, 9, 0, 4, -13,
    0, 0, -4, 0, 0, 0, 0, 0,
    0, 0, -2, 0, -7, 0, 0, 0,
    0, 0, 0, -15, 0, -15, 0, 0,
    -18, 0, -1, 0, 0, -14, 0, 0,
    0, 0, -39, 0, -33, -30, -4, -45,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, -6, 0, -6, 0, 0, -22,
    0, -4, -14, 0, -18, 0, 0, 0,
    0, -50, 0, -33, -28, -16, -48, 0,
    -4, 0, 0, -4, 0, 0, 0, -2,
    0, -9, -11, -9, -10, 0, 2, 0,
    8, 11, 0, -5, 0, 0, 0, 0,
    -35, 0, -23, -15, 8, -34, 0, 1,
    0, -2, 6, 0, 0, 0, 10, 0,
    0, 3, 0, 6, 0, 0, 6, 0,
    0, 0, 5, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, -2, 0, 7, -1,
    0, -11, 0, 0, 0, 0, -32, 0,
    -29, -22, -6, -41, 0, 0, 0, 0,
    0, 0, 0, 5, 0, 0, -1, -3,
    -1, 0, 0, 21, 0, -3, -34, 0,
    20, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, -12, 0, -11, 1,
    0, 0, 0, 6, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, -12,
    0, 0, 0, 0, -41, 0, -22, -19,
    0, -38, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 5, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 19, 0,
    0, 0, 0, 0, 0, 0, 0, -10,
    0, 0, -12, 11, 0, -22, 0, 0,
    0, 0, -41, 0, -27, -25, 0, -38,
    0, -13, 0, -10, 0, 0, 0, -5,
    0, -4, 0, 0, 0, 0, 0, 11,
    0, 4, -48, -21, -13, 0, 0, -53,
    0, 0, 0, -19, 0, -23, -34, 0,
    -19, 0, -15, 0, 0, 0, -3, 13,
    0, 0, 0, 0, 0, 0, -13, 0,
    0, 0, 0, -14, 0, 0, 0, 0,
    -45, 0, -32, -22, -2, -47, 0, 0,
    0, 0, 0, 0, 0, 4, 0, 0,
    -4, 0, -4, 5, 0, -3, 4, -1,
    13, 0, -11, 0, 0, 0, 0, -31,
    0, -21, 0, -1, -30, 0, 0, 0,
    -4, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, -41,
    -19, -12, 0, 0, -36, 0, -47, 0,
    -20, -10, -27, -33, 0, -9, 0, -9,
    0, 0, 0, -4, 0, 0, 0, 0,
    0, 0, 0, 0, 0, -9, 4, 0,
    -18, 0, 0, 0, 0, -48, 0, -25,
    -15, 0, -31, 0, -7, 0, -11, 0,
    0, 0, 0, 6, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 4, 0, -14,
    0, 0, 0, 0, -44, 0, -25, -14,
    0, -33, 0, -7, 0, -10, 0, 0,
    0, 1, 0, 0, 0, 0, 0, 0
};


/*Collect the kern class' data in one place*/
static const lv_font_fmt_txt_kern_classes_t kern_classes =
{
    .class_pair_values   = kern_class_values,
    .left_class_mapping  = kern_left_class_mapping,
    .right_class_mapping = kern_right_class_mapping,
    .left_class_cnt      = 40,
    .right_class_cnt     = 31,
};

/*--------------------
 *  ALL CUSTOM DATA
 *--------------------*/

#if LVGL_VERSION_MAJOR >= 8
/*Store all the custom data of the font*/
static  lv_font_fmt_txt_glyph_cache_t cache;
static const lv_font_fmt_txt_dsc_t font_dsc = {
#else
static lv_font_fmt_txt_dsc_t font_dsc = {
#endif
    .glyph_bitmap = Number_HarmonyOS_bpp4_28px_glyph_bitmap,
    .glyph_dsc = Number_HarmonyOS_bpp4_28px_glyph_dsc,
    .cmaps = cmaps,
    .kern_dsc = &kern_classes,
    .kern_scale = 16,
    .cmap_num = 1,
    .bpp = 4,
    .kern_classes = 1,
    .bitmap_format = 0,
#if LVGL_VERSION_MAJOR >= 8
    .cache = &cache
#endif
};


/*-----------------
 *  PUBLIC FONT
 *----------------*/

/*Initialize a public general font descriptor*/
#if LVGL_VERSION_MAJOR >= 8
const lv_font_t Number_HarmonyOS_bpp4_28px = {
#else
lv_font_t Number_HarmonyOS_bpp4_28px = {
#endif
    .get_glyph_dsc = lv_font_get_glyph_dsc_fmt_txt,    /*Function pointer to get glyph's data*/
    .get_glyph_bitmap = lv_font_get_bitmap_fmt_txt,    /*Function pointer to get glyph's bitmap*/
    .line_height = 32,          /*The maximum line height required by the font*/
    .base_line = 7,             /*Baseline measured from the bottom of the line*/
#if !(LVGL_VERSION_MAJOR == 6 && LVGL_VERSION_MINOR == 0)
    .subpx = LV_FONT_SUBPX_NONE,
#endif
#if LV_VERSION_CHECK(7, 4, 0) || LVGL_VERSION_MAJOR >= 8
    .underline_position = -2,
    .underline_thickness = 1,
#endif
    .dsc = &font_dsc           /*The custom font data. Will be accessed by `get_glyph_bitmap/dsc` */
};



#endif /*#if NUMBER_HARMONYOS_BPP4_28PX*/

